2019-07-31 16:20:07

by Takashi Iwai

[permalink] [raw]
Subject: [PATCH linux-firmware] Install only listed firmware files

The current make-install procedure leaves lots of garbage files that
aren't really firmware files in /lib/firmware.

Instead of copy-all-and-prune approach, copy only the listed files and
links in WHENCE by make-install for assuring only the proper firmware
files.

Signed-off-by: Takashi Iwai <[email protected]>
---
Makefile | 5 +----
copy-firmware.sh | 30 ++++++++++++++++++++++++++++++
2 files changed, 31 insertions(+), 4 deletions(-)
create mode 100755 copy-firmware.sh

diff --git a/Makefile b/Makefile
index d1163b871096..16b5b1a02a49 100644
--- a/Makefile
+++ b/Makefile
@@ -10,7 +10,4 @@ check:

install:
mkdir -p $(DESTDIR)$(FIRMWAREDIR)
- cp -r * $(DESTDIR)$(FIRMWAREDIR)
- rm -rf $(DESTDIR)$(FIRMWAREDIR)/usbdux
- find $(DESTDIR)$(FIRMWAREDIR) \( -name 'WHENCE' -or -name 'LICENSE.*' -or \
- -name 'LICENCE.*' \) -exec rm -- {} \;
+ ./copy-firmware.sh $(DESTDIR)$(FIRMWAREDIR)
diff --git a/copy-firmware.sh b/copy-firmware.sh
new file mode 100755
index 000000000000..7b276e271cfa
--- /dev/null
+++ b/copy-firmware.sh
@@ -0,0 +1,30 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0
+#
+# Copy firmware files based on WHENCE list
+#
+
+verbose=:
+if [ x"$1" = x"-v" ]; then
+ verbose=echo
+ shift
+fi
+
+destdir="$1"
+
+grep '^File:' WHENCE | sed -e's/^File: *//g' -e's/"//g' | while read f; do
+ test -f "$f" || continue
+ $verbose "copying file $f"
+ mkdir -p $destdir/$(dirname "$f")
+ cp -d "$f" $destdir/"$f"
+done
+
+grep -E '^Link:' WHENCE | sed -e's/^Link: *//g' -e's/-> //g' | while read f d; do
+ test -L "$f" || continue
+ test -f "$destdir/$f" && continue
+ $verbose "copying link $f"
+ mkdir -p $destdir/$(dirname "$f")
+ cp -d "$f" $destdir/"$f"
+done
+
+exit 0
--
2.16.4


2019-08-15 14:34:29

by Josh Boyer

[permalink] [raw]
Subject: Re: [PATCH linux-firmware] Install only listed firmware files

On Wed, Jul 31, 2019 at 12:17 PM Takashi Iwai <[email protected]> wrote:
>
> The current make-install procedure leaves lots of garbage files that
> aren't really firmware files in /lib/firmware.
>
> Instead of copy-all-and-prune approach, copy only the listed files and
> links in WHENCE by make-install for assuring only the proper firmware
> files.
>
> Signed-off-by: Takashi Iwai <[email protected]>

Thanks! Applied and pushed out.

josh